/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package calllog;

import java.io.IOException;
import java.io.InputStream;
import java.net.ServerSocket;
import java.net.Socket;

/**
 *
 * @author user
 */
public class CallLog {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        try {
            ServerSocket listener = new ServerSocket(7785);

            while (true) {
                try (Socket socket = listener.accept()) {
                    String inputResponse = GetResponse(socket.getInputStream());
                    String callState = GetValue(inputResponse, "CallState");
                    String callId = GetValue(inputResponse, "CallId");
                    String caller = GetValue(inputResponse, "Caller");
                    String callee = GetValue(inputResponse, "Callee");

                    switch (callState) {
                        case "Ringing": {
                            System.out.println("Incoming call");
                            System.out.println("    CallId: " + callId);
                            System.out.println("    " + caller + " -> " + callee);
                            break;
                        }
                        case "InCall": {
                            System.out.println("Start call");
                            System.out.println("    CallId: " + callId);
                            System.out.println("    " + caller + " -> " + callee);
                            break;
                        }
                        case "Completed": {
                            System.out.println("End call");
                            System.out.println("    CallId: " + callId);
                            System.out.println("    " + caller + " -> " + callee);
                            break;
                        }
                        case "Busy":
                        case "NoAnswer": {
                            System.out.println("Unsuccessful call");
                            System.out.println("    CallId: " + callId);
                            System.out.println("    " + caller + " -> " + callee);
                            break;
                        }
                    }

                    System.out.println("");
                }
            }
        } catch (Exception ex) {
            System.out.println(ex.getMessage());
        }
    }

    private static String GetResponse(InputStream pInputStream) throws IOException {
        byte[] b = new byte[pInputStream.available()];
        pInputStream.read(b);

        return new String(b);
    }

    private static String GetValue(String pContent, String pInfoName) {
        String value;

        int beginIndex = pContent.indexOf(pInfoName);
        int endIndex = pContent.indexOf("&", beginIndex);

        value = pContent.substring(beginIndex, endIndex).split("=")[1];

        return value;
    }
}
