/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package callrecording;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.ServerSocket;
import java.net.Socket;

/**
 *
 * @author user
 */
public class CallRecording {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws IOException {
        try (ServerSocket listener = new ServerSocket(7786)) {
            while (true) {
                try (Socket socket = listener.accept()) {
                    String inputResponse = GetResponse(socket.getInputStream());
                    String callState = GetValue(inputResponse, "CallState");
                    String callId = GetValue(inputResponse, "CallId");
                    switch (callState) {
                        case "InCall":
                            System.out.println("Start recording...(" + callId + ")");
                            break;
                        case "Completed":
                            System.out.println("Stop recording.(" + callId + ")");
                            break;
                    }

                    String responseContent = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\r\n"
                            + "<Response><Record finishedUrl=\"http://localhost:7787\" format=\"mp3\"/></Response>";

                    OutputStream outputStream = socket.getOutputStream();

                    outputStream.write(CreateHttpResponse(responseContent).getBytes());
                    outputStream.flush();

                    socket.close();
                }
            }
        }
    }

    private static String CreateHttpResponse(String pContent) {
        String header = "HTTP/1.0 200 OK\r\n"
                + "Content-Type: text/xml\r\n"
                + "Connection: Keep-Alive\r\n"
                + "Keep-Alive: timeout=15, max=100\r\n\r\n";

        StringBuilder response = new StringBuilder();

        response.append(header);
        response.append(pContent);

        return new String(response);
    }

    private static String GetResponse(InputStream pInputStream) throws IOException {
        byte[] b = new byte[pInputStream.available()];
        pInputStream.read(b);

        return new String(b);
    }

    private static String GetValue(String pContent, String pInfoName) {
        String value;

        int beginIndex = pContent.indexOf(pInfoName);
        int endIndex = pContent.indexOf("&", beginIndex);

        value = pContent.substring(beginIndex, endIndex).split("=")[1];

        return value;
    }   
}
