/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package callrouting;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.ServerSocket;
import java.net.Socket;

/**
 *
 * @author user
 */
public class CallRouting {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws IOException {
        try (ServerSocket listener = new ServerSocket(7788)) {
            while (true) {
                try (Socket socket = listener.accept()) {

                    String inputResponse = GetResponse(socket.getInputStream());

                    String dialedNumber = GetValue(inputResponse, "DialedNumber");
                    String lastCallState = GetValue(inputResponse, "LastCallState");

                    if (lastCallState.equals("Busy") || lastCallState.equals("NoAnswer")) {
                        String responseContent = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\r\n" +
                                                 "<Response><Route>9998</Route></Response>";

                        OutputStream outputStream = socket.getOutputStream();
                        outputStream.write(CreateHttpResponse(responseContent).getBytes());
                        outputStream.flush();
                    } else if (dialedNumber.equals("9999")) {
                        String responseContent = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\r\n" +
                                                 "<Response><Route RingTime = \"1\">1100</Route></Response>";

                        OutputStream outputStream = socket.getOutputStream();
                        outputStream.write(CreateHttpResponse(responseContent).getBytes());
                        outputStream.flush();
                    }
                    socket.close();
                }
            }
        }
    }

    private static String GetResponse(InputStream pInputStream) throws IOException {
        byte[] b = new byte[pInputStream.available()];
        pInputStream.read(b);

        return new String(b);
    }

    private static String GetValue(String pContent, String pInfoName) {
        String value;

        int beginIndex = pContent.indexOf(pInfoName);
        int endIndex = pContent.indexOf("&", beginIndex);

        value = pContent.substring(beginIndex, endIndex).split("=")[1];

        return value;
    }

    private static String CreateHttpResponse(String pContent) {
        String header = "HTTP/1.0 200 OK\r\n"
                + "Content-Type: text/xml\r\n"
                + "Connection: Keep-Alive\r\n"
                + "Keep-Alive: timeout=15, max=100\r\n\r\n";

        StringBuilder response = new StringBuilder();

        response.append(header);
        response.append(pContent);

        return new String(response);
    }
}
